<?
if(!defined('B_PROLOG_INCLUDED') || B_PROLOG_INCLUDED!==true) die();

class CASDUser extends CUser
{
	function GetList(&$by, &$order, $arFilter=Array(), $arParams=Array())
	{
		$err_mess = (CUser::err_mess())."<br>Function: GetList<br>Line: ";
		global $DB, $USER, $USER_FIELD_MANAGER;

		$obUserFieldsSql = new CUserTypeSQL;
		$obUserFieldsSql->SetEntity("USER", "U.ID");
		$obUserFieldsSql->SetSelect($arParams["SELECT"]);
		$obUserFieldsSql->SetFilter($arFilter);
		$obUserFieldsSql->SetOrder(array($by=>$order));

		$arFields_m = array("ID", "ACTIVE", "LAST_LOGIN", "LOGIN", "EMAIL", "NAME", "LAST_NAME", "SECOND_NAME", "TIMESTAMP_X", "PERSONAL_BIRTHDAY");
		$arFields = array("DATE_REGISTER", "PERSONAL_PROFESSION", "PERSONAL_WWW", "PERSONAL_ICQ", "PERSONAL_GENDER", "PERSONAL_PHOTO", "PERSONAL_PHONE", "PERSONAL_FAX", "PERSONAL_MOBILE", "PERSONAL_PAGER", "PERSONAL_STREET", "PERSONAL_MAILBOX", "PERSONAL_CITY", "PERSONAL_STATE", "PERSONAL_ZIP", "PERSONAL_COUNTRY", "PERSONAL_NOTES", "WORK_COMPANY", "WORK_DEPARTMENT", "WORK_POSITION", "WORK_WWW", "WORK_PHONE", "WORK_FAX", "WORK_PAGER", "WORK_STREET", "WORK_MAILBOX", "WORK_CITY", "WORK_STATE", "WORK_ZIP", "WORK_COUNTRY", "WORK_PROFILE", "WORK_NOTES", "ADMIN_NOTES", "XML_ID", "LAST_NAME", "SECOND_NAME");
		$arFields_all = array_merge($arFields_m, $arFields);
		$arSqlSearch = Array();
		$strSqlSearch = "";
		$strJoin = "";

		if(is_array($arFilter))
		{
			foreach ($arFilter as $key => $val)
			{
				$key = strtoupper($key);
				if(is_array($val))
				{
					if(count($val) <= 0)
						continue;
				}
				elseif(
					$key != "LOGIN_EQUAL_EXACT"
					&& $key != "CONFIRM_CODE"
					&& $key != "!CONFIRM_CODE"
				)
				{
					if( (strlen($val) <= 0) || ($val === "NOT_REF") )
						continue;
				}
				$match_value_set = array_key_exists($key."_EXACT_MATCH", $arFilter);
				switch($key)
				{
				case "ID":
					$arSqlSearch[] = GetFilterQuery("U.ID",$val,"N");
					break;
				case ">ID":
					$arSqlSearch[] = "U.ID > ".intval($val);
					break;
				case "!ID":
					$arSqlSearch[] = "U.ID <> ".intval($val);
					break;
				case "ID_EQUAL_EXACT":
					$arSqlSearch[] = "U.ID='".intval($val)."'";
					break;
				case ">PERSONAL_PHOTO":
					$arSqlSearch[] = "U.PERSONAL_PHOTO>'".intval($val)."'";
					break;
				case "TIMESTAMP_1":
					$arSqlSearch[] = "U.TIMESTAMP_X >= FROM_UNIXTIME('".MkDateTime(FmtDate($val,"D.M.Y"),"d.m.Y")."')";
					break;
				case "TIMESTAMP_2":
					$arSqlSearch[] = "U.TIMESTAMP_X <= FROM_UNIXTIME('".MkDateTime(FmtDate($val,"D.M.Y")." 23:59:59","d.m.Y")."')";
					break;
				case "TIMESTAMP_X_1":
					$arSqlSearch[] = "U.TIMESTAMP_X >= FROM_UNIXTIME('".MkDateTime(FmtDate($val,"DD.MM.YYYY HH:MI:SS"),"d.m.Y H:i:s")."')";
					break;
				case "TIMESTAMP_X_2":
					$arSqlSearch[] = "U.TIMESTAMP_X <= FROM_UNIXTIME('".MkDateTime(FmtDate($val,"DD.MM.YYYY HH:MI:SS"),"d.m.Y H:i:s")."')";
					break;
				case "LAST_LOGIN_1":
					$arSqlSearch[] = "U.LAST_LOGIN >= FROM_UNIXTIME('".MkDateTime(FmtDate($val,"D.M.Y"),"d.m.Y")."')";
					break;
				case "LAST_LOGIN_2":
					$arSqlSearch[] = "U.LAST_LOGIN <= FROM_UNIXTIME('".MkDateTime(FmtDate($val,"D.M.Y")." 23:59:59","d.m.Y")."')";
					break;
				case "DATE_REGISTER_1":
					$arSqlSearch[] = "U.DATE_REGISTER >= FROM_UNIXTIME('".MkDateTime(FmtDate($val,"D.M.Y"),"d.m.Y")."')";
					break;
				case "DATE_REGISTER_2":
					$arSqlSearch[] = "U.DATE_REGISTER <= FROM_UNIXTIME('".MkDateTime(FmtDate($val,"D.M.Y")." 23:59:59","d.m.Y")."')";
					break;
				case "ACTIVE":
					$arSqlSearch[] = ($val=="Y") ? "U.ACTIVE='Y'" : "U.ACTIVE='N'";
					break;
				case "LOGIN_EQUAL":
					$arSqlSearch[] = GetFilterQuery("U.LOGIN", $val, "N");
					break;
				case "LOGIN":
					$arSqlSearch[] = GetFilterQuery("U.LOGIN", $val);
					break;
				case "EXTERNAL_AUTH_ID":
					$arSqlSearch[] = "U.EXTERNAL_AUTH_ID='".$DB->ForSQL($val, 255)."'";
					break;
				case "LOGIN_EQUAL_EXACT":
					$arSqlSearch[] = "U.LOGIN='".$DB->ForSql($val)."'";
					break;
				case "XML_ID":
					$arSqlSearch[] = "U.XML_ID='".$DB->ForSql($val)."'";
					break;
				case "CONFIRM_CODE":
					if(strlen($val) > 0)
						$arSqlSearch[] = "U.CONFIRM_CODE='".$DB->ForSql($val)."'";
					else
						$arSqlSearch[] = "(U.CONFIRM_CODE IS NULL OR LENGTH(U.CONFIRM_CODE) <= 0)";
					break;
				case "!CONFIRM_CODE":
					if(strlen($val) > 0)
						$arSqlSearch[] = "U.CONFIRM_CODE <> '".$DB->ForSql($val)."'";
					else
						$arSqlSearch[] = "(U.CONFIRM_CODE IS NOT NULL AND LENGTH(U.CONFIRM_CODE) > 0)";
					break;
				case "COUNTRY_ID":
				case "WORK_COUNTRY":
					$arSqlSearch[] = "U.WORK_COUNTRY=".intval($val);
					break;
				case "PERSONAL_COUNTRY":
					$arSqlSearch[] = "U.PERSONAL_COUNTRY=".intval($val);
					break;
				case "NAME":
					$arSqlSearch[] = GetFilterQuery("U.NAME, U.LAST_NAME, U.SECOND_NAME", $val);
					break;
				case "NAME_SEARCH":
					$arSqlSearch[] = GetFilterQuery("U.NAME, U.LAST_NAME, U.SECOND_NAME, U.EMAIL, U.LOGIN", $val);
					break;
				case "EMAIL":
					$arSqlSearch[] = GetFilterQuery("U.EMAIL", $val, "Y", array("@","_",".","-"));
					break;
				case "=EMAIL":
					$arSqlSearch[] = "U.EMAIL = '".$DB->ForSQL(trim($val))."'";
					break;
				case "GROUP_MULTI":
				case "GROUPS_ID":
					if(is_numeric($val) && intval($val)>0)
						$val = array($val);
					if(is_array($val) && count($val)>0)
					{
						$ar = array();
						foreach($val as $id)
							$ar[intval($id)] = intval($id);
						$strJoin .=
							" INNER JOIN (SELECT DISTINCT UG.USER_ID FROM b_user_group UG
							WHERE UG.GROUP_ID in (".implode(",", $ar).")
								and (UG.DATE_ACTIVE_FROM is null or	UG.DATE_ACTIVE_FROM <= ".$DB->CurrentTimeFunction().")
								and (UG.DATE_ACTIVE_TO is null or UG.DATE_ACTIVE_TO >= ".$DB->CurrentTimeFunction().")
							) UG ON UG.USER_ID=U.ID ";
					}
					break;
				case "PERSONAL_BIRTHDATE_1":
					$arSqlSearch[] = "U.PERSONAL_BIRTHDATE>=".$DB->CharToDateFunction($val);
					break;
				case "PERSONAL_BIRTHDATE_2":
					$arSqlSearch[] = "U.PERSONAL_BIRTHDATE<=".$DB->CharToDateFunction($val." 23:59:59");
					break;
				case "PERSONAL_BIRTHDAY_1":
					$arSqlSearch[] = "U.PERSONAL_BIRTHDAY>=".$DB->CharToDateFunction($DB->ForSql($val), "SHORT");
					break;
				case "PERSONAL_BIRTHDAY_2":
					$arSqlSearch[] = "U.PERSONAL_BIRTHDAY<=".$DB->CharToDateFunction($DB->ForSql($val), "SHORT");
					break;
				case "PERSONAL_BIRTHDAY_DATE":
					$arSqlSearch[] = "DATE_FORMAT(U.PERSONAL_BIRTHDAY, '%m-%d') = '".$DB->ForSql($val)."'";
					break;
				case "KEYWORDS":
					$arSqlSearch[] = GetFilterQuery(implode(",",$arFields), $val);
					break;
				case "CHECK_SUBORDINATE":
					if(is_array($val))
					{
						$strSubord = "0";
						foreach($val as $grp)
							$strSubord .= ",".intval($grp);
						if(intval($arFilter["CHECK_SUBORDINATE_AND_OWN"]) > 0)
							$arSqlSearch[] = "(U.ID=".intval($arFilter["CHECK_SUBORDINATE_AND_OWN"])." OR NOT EXISTS(SELECT 'x' FROM b_user_group UGS WHERE UGS.USER_ID=U.ID AND UGS.GROUP_ID NOT IN (".$strSubord.")))";
						else
							$arSqlSearch[] = "NOT EXISTS(SELECT 'x' FROM b_user_group UGS WHERE UGS.USER_ID=U.ID AND UGS.GROUP_ID NOT IN (".$strSubord."))";
					}
					break;
				case "NOT_ADMIN":
					if($val !== true)
						break;
					$arSqlSearch[] = "not exists (SELECT * FROM b_user_group UGNA WHERE UGNA.USER_ID=U.ID AND UGNA.GROUP_ID = 1)";
					break;
				case "LAST_ACTIVITY":
					$arSqlSearch[] = "U.LAST_ACTIVITY_DATE > DATE_SUB(NOW(), INTERVAL ".intval($val)." SECOND)";
					break;
				case "INTRANET_USERS":
					$arSqlSearch[] = "U.ACTIVE = 'Y' AND U.LAST_LOGIN IS NOT NULL AND EXISTS(SELECT 'x' FROM b_utm_user UF1, b_user_field F1 WHERE F1.ENTITY_ID = 'USER' AND F1.FIELD_NAME = 'UF_DEPARTMENT' AND UF1.FIELD_ID = F1.ID AND UF1.VALUE_ID = U.ID AND UF1.VALUE_INT IS NOT NULL AND UF1.VALUE_INT <> 0)";
					break;
				default:
					if(in_array($key, $arFields))
						$arSqlSearch[] = GetFilterQuery('U.'.$key, $val, ($arFilter[$key."_EXACT_MATCH"]=="Y" && $match_value_set? "N" : "Y"));
				}
			}
		}
		if($by == "CURRENT_BIRTHDAY")
		{
			$cur_year = intval(date('Y'));
			$strSqlOrder = " ORDER BY IF(ISNULL(PERSONAL_BIRTHDAY), '9999-99-99', IF (
				DATE_FORMAT(U.PERSONAL_BIRTHDAY, '".$cur_year."-%m-%d') < DATE_FORMAT(CURDATE(), '%Y-%m-%d'),
				DATE_FORMAT(U.PERSONAL_BIRTHDAY, '".($cur_year + 1)."-%m-%d'),
				DATE_FORMAT(U.PERSONAL_BIRTHDAY, '".$cur_year."-%m-%d')
			)) ";
		}
		elseif(in_array(strtoupper($by),$arFields_all))
		{
			$strSqlOrder = " ORDER BY U.".strtoupper($by);
		}
		elseif($s = $obUserFieldsSql->GetOrder($by))
		{
			$strSqlOrder = " ORDER BY ".strtoupper($s);
		}
		elseif(preg_match('/^RATING_(\d+)$/i', $by, $matches))
		{
			$ratingId = IntVal($matches[1]);
			if ($ratingId > 0)
			{
				$strSqlOrder = " ORDER BY ".$by."_ISNULL ASC, $by";
				$arParams['SELECT'][] = $by;
			} else {
				$strSqlOrder = " ORDER BY U.TIMESTAMP_X ";
				$by = "timestamp_x";
			}
		}
		else
		{
			$strSqlOrder = " ORDER BY U.TIMESTAMP_X ";
			$by = "timestamp_x";
		}

		if($order!="asc")
		{
			$strSqlOrder .= " desc ";
			$order = "desc";
		}

		$arSqlSearch[] = $obUserFieldsSql->GetFilter();
		$strSqlSearch = GetFilterSqlSearch($arSqlSearch);

		$online_interval = (array_key_exists("ONLINE_INTERVAL", $arParams) && intval($arParams["ONLINE_INTERVAL"]) > 0 ? $arParams["ONLINE_INTERVAL"] : 120);

		$sSelect = ($obUserFieldsSql->GetDistinct()? "DISTINCT" : "")."
			U.*,
			".$DB->DateToCharFunction("U.TIMESTAMP_X")." TIMESTAMP_X,
			IF(U.LAST_ACTIVITY_DATE > DATE_SUB(NOW(), INTERVAL ".$online_interval." SECOND), 'Y', 'N') IS_ONLINE,
			".$DB->DateToCharFunction("U.DATE_REGISTER")." DATE_REGISTER,
			".$DB->DateToCharFunction("U.LAST_LOGIN")." LAST_LOGIN,
			".$DB->DateToCharFunction("U.PERSONAL_BIRTHDAY", "SHORT")." PERSONAL_BIRTHDAY
			".$obUserFieldsSql->GetSelect()."
		";

		if (is_array($arParams['SELECT']))
		{
			$arRatingInSelect = array();
			foreach ($arParams['SELECT'] as $column)
			{
				if(preg_match('/^RATING_(\d+)$/i', $column, $matches))
				{
					$ratingId = IntVal($matches[1]);
					if ($ratingId > 0 && !in_array($ratingId, $arRatingInSelect))
					{
						$sSelect .= ", RR".$ratingId.".CURRENT_POSITION IS NULL as RATING_".$ratingId."_ISNULL";
						$sSelect .= ", RR".$ratingId.".CURRENT_VALUE as RATING_".$ratingId;
						$sSelect .= ", RR".$ratingId.".CURRENT_VALUE as RATING_".$ratingId."_CURRENT_VALUE";
						$sSelect .= ", RR".$ratingId.".PREVIOUS_VALUE as RATING_".$ratingId."_PREVIOUS_VALUE";
						$sSelect .= ", RR".$ratingId.".CURRENT_POSITION as RATING_".$ratingId."_CURRENT_POSITION";
						$sSelect .= ", RR".$ratingId.".PREVIOUS_POSITION as RATING_".$ratingId."_PREVIOUS_POSITION";
						$strJoin .=	" LEFT JOIN  b_rating_results RR".$ratingId."
										ON RR".$ratingId.".RATING_ID=".$ratingId."
										and RR".$ratingId.".ENTITY_TYPE_ID = 'USER'
										and RR".$ratingId.".ENTITY_ID = U.ID ";
						$arRatingInSelect[] = $ratingId;
					}
				}
			}
		}
		$strSql = "
			FROM
				b_user U
				".$obUserFieldsSql->GetJoin("U.ID")."
				".$strJoin."
			WHERE
				$strSqlSearch
			";

		if(array_key_exists("NAV_PARAMS", $arParams) && is_array($arParams["NAV_PARAMS"]))
		{
			$res_cnt = $DB->Query("SELECT COUNT(".($obUserFieldsSql->GetDistinct()? "DISTINCT ":"")."U.ID) as C ".$strSql);
			$res_cnt = $res_cnt->Fetch();
			$strSql = "SELECT ".$sSelect.$strSql.$strSqlOrder;
			$res = new CDBResult();
			$res->SetUserFields($USER_FIELD_MANAGER->GetUserFields("USER"));
			$res->NavQuery($strSql, $res_cnt["C"], $arParams["NAV_PARAMS"]);
		}
		else
		{
			$strSql = "SELECT ".$sSelect.$strSql.$strSqlOrder;
			$res = $DB->Query($strSql, false, $err_mess.__LINE__);
			$res->SetUserFields($USER_FIELD_MANAGER->GetUserFields("USER"));
		}

		$res->is_filtered = IsFiltered($strSqlSearch);
		return $res;
	}
}

if(!isset($arParams['CACHE_TIME']))
	$arParams['CACHE_TIME'] = 3600;

if ($arParams['PAGE_COUNT'] > 0)
{
	$arNavParams = array('nPageSize' => $arParams['PAGE_COUNT'], 'bShowAll' => false);
	$arNavigation = CDBResult::GetNavParams($arNavParams);
	$cacheID = array($arNavigation);
}
elseif ($arParams['PAGE_TOP'] > 0)
{
	$arNavParams = array('nTopCount' => $arParams['PAGE_TOP']);
	$arNavParams = array('nPageSize' => $arParams['PAGE_TOP'], 'bShowAll' => false);//temporary, because nTopCount not working
	$arNavigation = CDBResult::GetNavParams($arNavParams);
	$cacheID = array($arNavigation);
}

if ($this->StartResultCache(false, $cacheID))
{
	$arResult = array();
	$arResult['ITEMS'] = array();

	$arFilter = array();
	if (trim($arParams['FILTER']) != '')
	{
		$arParams['FILTER'] = explode('|', $arParams['~FILTER']);
		foreach ($arParams['FILTER'] as $slice)
		{
			if ($slice != '')
			{
				list($k, $v) = explode('=', $slice);
				$arFilter[$k] = $v;
			}
		}
	}
	if (($arParams['SORT_BY']=='RAND' || $arParams['SORT_BY']=='rand') && $arParams['PAGE_TOP']>0)
	{
		$arIDs = array();
		$rsUsers = CASDUser::GetList($by=$arParams['SORT_BY'], $order=$arParams['SORT_ORDER'], $arFilter);
		while ($arUsers = $rsUsers->GetNext())
			$arIDs[] = $arUsers['ID'];

		if (count($arIDs) > $arParams['PAGE_TOP'])
		{
			shuffle($arIDs);
			$arIDs = array_pop(array_reverse(array_chunk($arIDs, $arParams['PAGE_TOP'])));
		}

		$arFilter['ID'] = implode('|', $arIDs);
	}

	$rsUsers = CASDUser::GetList($by=$arParams['SORT_BY'], $order=$arParams['SORT_ORDER'], $arFilter, array('NAV_PARAMS' => $arNavParams));
	while ($arUsers = $rsUsers->GetNext())
	{
		if ($arUsers['PERSONAL_PHOTO']>0 && $arParams['GET_AVATAR']=='Y')
		{
			if ($arParams['AVA_WIDTH']>0 && $arParams['AVA_HEIGHT']>0)
			{
				$arUsers['PERSONAL_PHOTO_SRC'] = CFile::ResizeImageGet($arUsers['PERSONAL_PHOTO'], array('width' => $arParams['AVA_WIDTH'], 'height' => $arParams['AVA_HEIGHT']));
				$arUsers['PERSONAL_PHOTO_SRC']['SRC'] = $arUsers['PERSONAL_PHOTO_SRC']['src'];
			}
			else
				$arUsers['PERSONAL_PHOTO_SRC'] = CFile::GetFileArray($arUsers['PERSONAL_PHOTO']);
		}
		$arResult['ITEMS'][] = $arUsers;
	}

	if ($arParams['PAGE_COUNT'] > 0)
		$arResult['NAV_STRING'] = $rsUsers->GetPageNavStringEx($navComponentObject, '', $arParams['PAGER_TEMPLATE']);

	$this->IncludeComponentTemplate();
}
?>